YAHOO.namespace('ExternalBugs');
YAHOO.ExternalBugs.extUpdateAllRPC = function () {
    var extRefreshList = YAHOO.ExternalBugs.extRefreshList;
    for (var i = 0; i < extRefreshList.length; i++) {
        YAHOO.util.Dom.get('ext_waiting_' + extRefreshList[i]).style.visibility = 'visible';
        var callback = {
            success:function(o) {

                try {
                    result = YAHOO.lang.JSON.parse(o.responseText);
                }
                catch(x) {
                    alert("JSON Parse failed! Please try again.");
                    return;
                }
                YAHOO.ExternalBugs.extUpdateRowData(result.result);
            },
        }
        var json_object = {
            method: "ExternalBugs.get_ext_data",
            params: {
                Bugzilla_api_token: BUGZILLA.api_token,
                id : extRefreshList[i]
            },
            id: "1",
            version: "1.1"
        };
        var postData = YAHOO.lang.JSON.stringify(json_object);
        YAHOO.util.Connect.setDefaultPostHeader(false);
        YAHOO.util.Connect.initHeader('Content-Type','application/json');
        YAHOO.util.Connect.initHeader('X-Bugzilla-Internal', 'yes');
        YAHOO.util.Connect.asyncRequest('POST','jsonrpc.cgi', callback, postData);
    }
}

YAHOO.ExternalBugs.extUpdateRow = function (my_id) {
    YAHOO.util.Dom.get('ext_waiting_' + my_id).style.visibility = 'visible';

    var rpc;
    var data = {};

    data['Bugzilla_api_token'] = BUGZILLA.api_token;
    data['id'] = my_id;

    return rpc = new Rpc('ExternalBugs', 'get_ext_data', data)
        .fail(function (error) {
            YAHOO.util.Dom.get('ext_waiting_' + my_id).style.visibility = 'hidden';
            alertify.error(error.message);
        })
        .done(function (res) {
            YAHOO.ExternalBugs.extUpdateRowData(res);
            alertify.success("ExternalBug " + res.ext_bz_bug_id + " updated!");
        });
}

YAHOO.ExternalBugs.extUpdateRowData = function (data) {
    YAHOO.util.Dom.get('ext_status_' + data.id).innerHTML = data.ext_status;
    YAHOO.util.Dom.get('ext_description_' + data.id).innerHTML = data.ext_description;
    YAHOO.util.Dom.get('ext_description_' + data.id).title = data.ext_description;
    YAHOO.util.Dom.get('ext_priority_' + data.id).innerHTML = data.ext_priority;
    YAHOO.util.Dom.get('ext_last_updated_' + data.id).innerHTML = data.ext_last_updated;
    YAHOO.util.Dom.get('ext_waiting_' + data.id).style.visibility = 'hidden';
}
YAHOO.util.Event.onDOMReady(YAHOO.ExternalBugs.extUpdateAllRPC);

YAHOO.ExternalBugs.extRemoveRow = function (my_id) {
    YAHOO.util.Dom.get('ext_waiting_' + my_id).style.visibility = 'visible';

    var rpc;
    var data = {};

    data['Bugzilla_api_token'] = BUGZILLA.api_token;
    data['ids'] = [my_id];
    data['minor_update'] = 1;

    return rpc = new Rpc('ExternalBugs', 'remove_external_bug', data)
        .fail(function (error) {
            YAHOO.util.Dom.get('ext_waiting_' + my_id).style.visibility = 'hidden';
            alertify.error(error.message);
        })
        .done(function (res) {
            alertify.success("ExternalBug removed!");
            $('#ext_row_' + my_id).remove();
        });
}
